/** 
 * vis-data - data
 * http://visjs.org/
 * 
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 * 
 * @version 5.0.0
 * @date    2019-07-12T20:53:22Z
 * 
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2018-2019 visjs contributors, https://github.com/visjs
 * 
 * @license 
 * vis.js is dual licensed under both
 * 
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 *   and
 * 
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 * 
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t=t||self).vis={})}(this,function(t){"use strict";function f(t){return(f="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function er(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function e(t,e){return t(e={exports:{}},e.exports),e.exports}for(var i=e(function(tr,t){tr.exports=function(){var e,i;function l(){return e.apply(null,arguments)}function a(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function o(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function s(t){return void 0===t}function u(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function h(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function r(t,e){var n,r=[];for(n=0;n<t.length;++n)r.push(e(t[n],n));return r}function d(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function f(t,e){for(var n in e)d(e,n)&&(t[n]=e[n]);return d(e,"toString")&&(t.toString=e.toString),d(e,"valueOf")&&(t.valueOf=e.valueOf),t}function c(t,e,n,r){return Ee(t,e,n,r,!0).utc()}function m(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function _(t){if(null==t._isValid){var e=m(t),n=i.call(e.parsedDateParts,function(t){return null!=t}),r=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n);if(t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return r;t._isValid=r}return t._isValid}function p(t){var e=c(NaN);return null!=t?f(m(e),t):m(e).userInvalidated=!0,e}i=Array.prototype.some?Array.prototype.some:function(t){for(var e=Object(this),n=e.length>>>0,r=0;r<n;r++)if(r in e&&t.call(this,e[r],r,e))return!0;return!1};var y=l.momentProperties=[];function g(t,e){var n,r,i;if(s(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),s(e._i)||(t._i=e._i),s(e._f)||(t._f=e._f),s(e._l)||(t._l=e._l),s(e._strict)||(t._strict=e._strict),s(e._tzm)||(t._tzm=e._tzm),s(e._isUTC)||(t._isUTC=e._isUTC),s(e._offset)||(t._offset=e._offset),s(e._pf)||(t._pf=m(e)),s(e._locale)||(t._locale=e._locale),0<y.length)for(n=0;n<y.length;n++)r=y[n],s(i=e[r])||(t[r]=i);return t}var n=!1;function v(t){g(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===n&&(n=!0,l.updateOffset(this),n=!1)}function w(t){return t instanceof v||null!=t&&null!=t._isAMomentObject}function b(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function S(t){var e=+t,n=0;return 0!=e&&isFinite(e)&&(n=b(e)),n}function D(t,e,n){var r,i=Math.min(t.length,e.length),s=Math.abs(t.length-e.length),a=0;for(r=0;r<i;r++)(n&&t[r]!==e[r]||!n&&S(t[r])!==S(e[r]))&&a++;return a+s}function k(t){!1===l.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function t(i,s){var a=!0;return f(function(){if(null!=l.deprecationHandler&&l.deprecationHandler(null,i),a){for(var t,e=[],n=0;n<arguments.length;n++){if(t="","object"==typeof arguments[n]){for(var r in t+="\n["+n+"] ",arguments[0])t+=r+": "+arguments[0][r]+", ";t=t.slice(0,-2)}else t=arguments[n];e.push(t)}k(i+"\nArguments: "+Array.prototype.slice.call(e).join("")+"\n"+(new Error).stack),a=!1}return s.apply(this,arguments)},s)}var M,O={};function x(t,e){null!=l.deprecationHandler&&l.deprecationHandler(t,e),O[t]||(k(e),O[t]=!0)}function Y(t){return t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function T(t,e){var n,r=f({},t);for(n in e)d(e,n)&&(o(t[n])&&o(e[n])?(r[n]={},f(r[n],t[n]),f(r[n],e[n])):null!=e[n]?r[n]=e[n]:delete r[n]);for(n in t)d(t,n)&&!d(e,n)&&o(t[n])&&(r[n]=f({},r[n]));return r}function P(t){null!=t&&this.set(t)}l.suppressDeprecationWarnings=!1,l.deprecationHandler=null,M=Object.keys?Object.keys:function(t){var e,n=[];for(e in t)d(t,e)&&n.push(e);return n};var C={};function E(t,e){var n=t.toLowerCase();C[n]=C[n+"s"]=C[e]=t}function I(t){return"string"==typeof t?C[t]||C[t.toLowerCase()]:void 0}function A(t){var e,n,r={};for(n in t)d(t,n)&&(e=I(n))&&(r[e]=t[n]);return r}var N={};function j(t,e){N[t]=e}function R(t){var e=[];for(var n in t)e.push({unit:n,priority:N[n]});return e.sort(function(t,e){return t.priority-e.priority}),e}function H(t,e,n){var r=""+Math.abs(t),i=e-r.length,s=0<=t;return(s?n?"+":"":"-")+Math.pow(10,Math.max(0,i)).toString().substr(1)+r}var W=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,V=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,U={},F={};function G(t,e,n,r){var i=r;"string"==typeof r&&(i=function(){return this[r]()}),t&&(F[t]=i),e&&(F[e[0]]=function(){return H(i.apply(this,arguments),e[1],e[2])}),n&&(F[n]=function(){return this.localeData().ordinal(i.apply(this,arguments),t)})}function L(t){return t.match(/\[[\s\S]/)?t.replace(/^\[|\]$/g,""):t.replace(/\\/g,"")}function B(t,e){return t.isValid()?(e=q(e,t.localeData()),U[e]=U[e]||function(r){var t,i,s=r.match(W);for(t=0,i=s.length;t<i;t++)F[s[t]]?s[t]=F[s[t]]:s[t]=L(s[t]);return function(t){var e,n="";for(e=0;e<i;e++)n+=Y(s[e])?s[e].call(t,r):s[e];return n}}(e),U[e](t)):t.localeData().invalidDate()}function q(t,e){var n=5;function r(t){return e.longDateFormat(t)||t}for(V.lastIndex=0;0<=n&&V.test(t);)t=t.replace(V,r),V.lastIndex=0,n-=1;return t}var z=/\d/,Z=/\d\d/,$=/\d{3}/,Q=/\d{4}/,J=/[+-]?\d{6}/,X=/\d\d?/,K=/\d\d\d\d?/,tt=/\d\d\d\d\d\d?/,et=/\d{1,3}/,nt=/\d{1,4}/,rt=/[+-]?\d{1,6}/,it=/\d+/,st=/[+-]?\d+/,at=/Z|[+-]\d\d:?\d\d/gi,ot=/Z|[+-]\d\d(?::?\d\d)?/gi,ut=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,lt={};function ht(t,n,r){lt[t]=Y(n)?n:function(t,e){return t&&r?r:n}}function dt(t,e){return d(lt,t)?lt[t](e._strict,e._locale):new RegExp(function(t){return ft(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,function(t,e,n,r,i){return e||n||r||i}))}(t))}function ft(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var ct={};function mt(t,n){var e,r=n;for("string"==typeof t&&(t=[t]),u(n)&&(r=function(t,e){e[n]=S(t)}),e=0;e<t.length;e++)ct[t[e]]=r}function _t(t,i){mt(t,function(t,e,n,r){n._w=n._w||{},i(t,n._w,n,r)})}function pt(t,e,n){null!=e&&d(ct,t)&&ct[t](e,n._a,n,t)}var yt=0,gt=1,vt=2,wt=3,bt=4,St=5,Dt=6,kt=7,Mt=8;function Ot(t){return xt(t)?366:365}function xt(t){return t%4==0&&t%100!=0||t%400==0}G("Y",0,0,function(){var t=this.year();return t<=9999?""+t:"+"+t}),G(0,["YY",2],0,function(){return this.year()%100}),G(0,["YYYY",4],0,"year"),G(0,["YYYYY",5],0,"year"),G(0,["YYYYYY",6,!0],0,"year"),E("year","y"),j("year",1),ht("Y",st),ht("YY",X,Z),ht("YYYY",nt,Q),ht("YYYYY",rt,J),ht("YYYYYY",rt,J),mt(["YYYYY","YYYYYY"],yt),mt("YYYY",function(t,e){e[yt]=2===t.length?l.parseTwoDigitYear(t):S(t)}),mt("YY",function(t,e){e[yt]=l.parseTwoDigitYear(t)}),mt("Y",function(t,e){e[yt]=parseInt(t,10)}),l.parseTwoDigitYear=function(t){return S(t)+(68<S(t)?1900:2e3)};var Yt,Tt=Pt("FullYear",!0);function Pt(e,n){return function(t){return null!=t?(Et(this,e,t),l.updateOffset(this,n),this):Ct(this,e)}}function Ct(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function Et(t,e,n){t.isValid()&&!isNaN(n)&&("FullYear"===e&&xt(t.year())&&1===t.month()&&29===t.date()?t._d["set"+(t._isUTC?"UTC":"")+e](n,t.month(),It(n,t.month())):t._d["set"+(t._isUTC?"UTC":"")+e](n))}function It(t,e){if(isNaN(t)||isNaN(e))return NaN;var n=function(t,e){return(t%e+e)%e}(e,12);return t+=(e-n)/12,1===n?xt(t)?29:28:31-n%7%2}Yt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},G("M",["MM",2],"Mo",function(){return this.month()+1}),G("MMM",0,0,function(t){return this.localeData().monthsShort(this,t)}),G("MMMM",0,0,function(t){return this.localeData().months(this,t)}),E("month","M"),j("month",8),ht("M",X),ht("MM",X,Z),ht("MMM",function(t,e){return e.monthsShortRegex(t)}),ht("MMMM",function(t,e){return e.monthsRegex(t)}),mt(["M","MM"],function(t,e){e[gt]=S(t)-1}),mt(["MMM","MMMM"],function(t,e,n,r){var i=n._locale.monthsParse(t,r,n._strict);null!=i?e[gt]=i:m(n).invalidMonth=t});var At=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Nt="January_February_March_April_May_June_July_August_September_October_November_December".split("_");var jt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function Rt(t,e,n){var r,i,s,a=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],r=0;r<12;++r)s=c([2e3,r]),this._shortMonthsParse[r]=this.monthsShort(s,"").toLocaleLowerCase(),this._longMonthsParse[r]=this.months(s,"").toLocaleLowerCase();return n?"MMM"===e?-1!==(i=Yt.call(this._shortMonthsParse,a))?i:null:-1!==(i=Yt.call(this._longMonthsParse,a))?i:null:"MMM"===e?-1!==(i=Yt.call(this._shortMonthsParse,a))?i:-1!==(i=Yt.call(this._longMonthsParse,a))?i:null:-1!==(i=Yt.call(this._longMonthsParse,a))?i:-1!==(i=Yt.call(this._shortMonthsParse,a))?i:null}function Ht(t,e){var n;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=S(e);else if(!u(e=t.localeData().monthsParse(e)))return t;return n=Math.min(t.date(),It(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,n),t}function Wt(t){return null!=t?(Ht(this,t),l.updateOffset(this,!0),this):Ct(this,"Month")}var Vt=ut;var Ut=ut;function Ft(){function t(t,e){return e.length-t.length}var e,n,r=[],i=[],s=[];for(e=0;e<12;e++)n=c([2e3,e]),r.push(this.monthsShort(n,"")),i.push(this.months(n,"")),s.push(this.months(n,"")),s.push(this.monthsShort(n,""));for(r.sort(t),i.sort(t),s.sort(t),e=0;e<12;e++)r[e]=ft(r[e]),i[e]=ft(i[e]);for(e=0;e<24;e++)s[e]=ft(s[e]);this._monthsRegex=new RegExp("^("+s.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+i.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+r.join("|")+")","i")}function Gt(t){var e;if(t<100&&0<=t){var n=Array.prototype.slice.call(arguments);n[0]=t+400,e=new Date(Date.UTC.apply(null,n)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)}else e=new Date(Date.UTC.apply(null,arguments));return e}function Lt(t,e,n){var r=7+e-n,i=(7+Gt(t,0,r).getUTCDay()-e)%7;return r-i-1}function Bt(t,e,n,r,i){var s,a,o=(7+n-r)%7,u=Lt(t,r,i),l=1+7*(e-1)+o+u;return a=l<=0?Ot(s=t-1)+l:l>Ot(t)?(s=t+1,l-Ot(t)):(s=t,l),{year:s,dayOfYear:a}}function qt(t,e,n){var r,i,s=Lt(t.year(),e,n),a=Math.floor((t.dayOfYear()-s-1)/7)+1;return a<1?(i=t.year()-1,r=a+zt(i,e,n)):a>zt(t.year(),e,n)?(r=a-zt(t.year(),e,n),i=t.year()+1):(i=t.year(),r=a),{week:r,year:i}}function zt(t,e,n){var r=Lt(t,e,n),i=Lt(t+1,e,n);return(Ot(t)-r+i)/7}G("w",["ww",2],"wo","week"),G("W",["WW",2],"Wo","isoWeek"),E("week","w"),E("isoWeek","W"),j("week",5),j("isoWeek",5),ht("w",X),ht("ww",X,Z),ht("W",X),ht("WW",X,Z),_t(["w","ww","W","WW"],function(t,e,n,r){e[r.substr(0,1)]=S(t)});function Zt(t,e){return t.slice(e,7).concat(t.slice(0,e))}G("d",0,"do","day"),G("dd",0,0,function(t){return this.localeData().weekdaysMin(this,t)}),G("ddd",0,0,function(t){return this.localeData().weekdaysShort(this,t)}),G("dddd",0,0,function(t){return this.localeData().weekdays(this,t)}),G("e",0,0,"weekday"),G("E",0,0,"isoWeekday"),E("day","d"),E("weekday","e"),E("isoWeekday","E"),j("day",11),j("weekday",11),j("isoWeekday",11),ht("d",X),ht("e",X),ht("E",X),ht("dd",function(t,e){return e.weekdaysMinRegex(t)}),ht("ddd",function(t,e){return e.weekdaysShortRegex(t)}),ht("dddd",function(t,e){return e.weekdaysRegex(t)}),_t(["dd","ddd","dddd"],function(t,e,n,r){var i=n._locale.weekdaysParse(t,r,n._strict);null!=i?e.d=i:m(n).invalidWeekday=t}),_t(["d","e","E"],function(t,e,n,r){e[r]=S(t)});var $t="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_");var Qt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_");var Jt="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Xt(t,e,n){var r,i,s,a=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],r=0;r<7;++r)s=c([2e3,1]).day(r),this._minWeekdaysParse[r]=this.weekdaysMin(s,"").toLocaleLowerCase(),this._shortWeekdaysParse[r]=this.weekdaysShort(s,"").toLocaleLowerCase(),this._weekdaysParse[r]=this.weekdays(s,"").toLocaleLowerCase();return n?"dddd"===e?-1!==(i=Yt.call(this._weekdaysParse,a))?i:null:"ddd"===e?-1!==(i=Yt.call(this._shortWeekdaysParse,a))?i:null:-1!==(i=Yt.call(this._minWeekdaysParse,a))?i:null:"dddd"===e?-1!==(i=Yt.call(this._weekdaysParse,a))?i:-1!==(i=Yt.call(this._shortWeekdaysParse,a))?i:-1!==(i=Yt.call(this._minWeekdaysParse,a))?i:null:"ddd"===e?-1!==(i=Yt.call(this._shortWeekdaysParse,a))?i:-1!==(i=Yt.call(this._weekdaysParse,a))?i:-1!==(i=Yt.call(this._minWeekdaysParse,a))?i:null:-1!==(i=Yt.call(this._minWeekdaysParse,a))?i:-1!==(i=Yt.call(this._weekdaysParse,a))?i:-1!==(i=Yt.call(this._shortWeekdaysParse,a))?i:null}var Kt=ut;var te=ut;var ee=ut;function ne(){function t(t,e){return e.length-t.length}var e,n,r,i,s,a=[],o=[],u=[],l=[];for(e=0;e<7;e++)n=c([2e3,1]).day(e),r=this.weekdaysMin(n,""),i=this.weekdaysShort(n,""),s=this.weekdays(n,""),a.push(r),o.push(i),u.push(s),l.push(r),l.push(i),l.push(s);for(a.sort(t),o.sort(t),u.sort(t),l.sort(t),e=0;e<7;e++)o[e]=ft(o[e]),u[e]=ft(u[e]),l[e]=ft(l[e]);this._weekdaysRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+u.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+o.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function re(){return this.hours()%12||12}function ie(t,e){G(t,0,0,function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)})}function se(t,e){return e._meridiemParse}G("H",["HH",2],0,"hour"),G("h",["hh",2],0,re),G("k",["kk",2],0,function(){return this.hours()||24}),G("hmm",0,0,function(){return""+re.apply(this)+H(this.minutes(),2)}),G("hmmss",0,0,function(){return""+re.apply(this)+H(this.minutes(),2)+H(this.seconds(),2)}),G("Hmm",0,0,function(){return""+this.hours()+H(this.minutes(),2)}),G("Hmmss",0,0,function(){return""+this.hours()+H(this.minutes(),2)+H(this.seconds(),2)}),ie("a",!0),ie("A",!1),E("hour","h"),j("hour",13),ht("a",se),ht("A",se),ht("H",X),ht("h",X),ht("k",X),ht("HH",X,Z),ht("hh",X,Z),ht("kk",X,Z),ht("hmm",K),ht("hmmss",tt),ht("Hmm",K),ht("Hmmss",tt),mt(["H","HH"],wt),mt(["k","kk"],function(t,e,n){var r=S(t);e[wt]=24===r?0:r}),mt(["a","A"],function(t,e,n){n._isPm=n._locale.isPM(t),n._meridiem=t}),mt(["h","hh"],function(t,e,n){e[wt]=S(t),m(n).bigHour=!0}),mt("hmm",function(t,e,n){var r=t.length-2;e[wt]=S(t.substr(0,r)),e[bt]=S(t.substr(r)),m(n).bigHour=!0}),mt("hmmss",function(t,e,n){var r=t.length-4,i=t.length-2;e[wt]=S(t.substr(0,r)),e[bt]=S(t.substr(r,2)),e[St]=S(t.substr(i)),m(n).bigHour=!0}),mt("Hmm",function(t,e,n){var r=t.length-2;e[wt]=S(t.substr(0,r)),e[bt]=S(t.substr(r))}),mt("Hmmss",function(t,e,n){var r=t.length-4,i=t.length-2;e[wt]=S(t.substr(0,r)),e[bt]=S(t.substr(r,2)),e[St]=S(t.substr(i))});var ae,oe=Pt("Hours",!0),ue={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Nt,monthsShort:jt,week:{dow:0,doy:6},weekdays:$t,weekdaysMin:Jt,weekdaysShort:Qt,meridiemParse:/[ap]\.?m?\.?/i},le={},he={};function de(t){return t?t.toLowerCase().replace("_","-"):t}function fe(t){var e=null;if(!le[t]&&tr&&tr.exports)try{e=ae._abbr;var n=er;n("./locale/"+t),ce(e)}catch(t){}return le[t]}function ce(t,e){var n;return t&&((n=s(e)?_e(t):me(t,e))?ae=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),ae._abbr}function me(t,e){if(null===e)return delete le[t],null;var n,r=ue;if(e.abbr=t,null!=le[t])x("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),r=le[t]._config;else if(null!=e.parentLocale)if(null!=le[e.parentLocale])r=le[e.parentLocale]._config;else{if(null==(n=fe(e.parentLocale)))return he[e.parentLocale]||(he[e.parentLocale]=[]),he[e.parentLocale].push({name:t,config:e}),null;r=n._config}return le[t]=new P(T(r,e)),he[t]&&he[t].forEach(function(t){me(t.name,t.config)}),ce(t),le[t]}function _e(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return ae;if(!a(t)){if(e=fe(t))return e;t=[t]}return function(t){var e,n,r,i,s=0;for(;s<t.length;){for(i=de(t[s]).split("-"),e=i.length,n=(n=de(t[s+1]))?n.split("-"):null;0<e;){if(r=fe(i.slice(0,e).join("-")))return r;if(n&&n.length>=e&&D(i,n,!0)>=e-1)break;e--}s++}return ae}(t)}function pe(t){var e,n=t._a;return n&&-2===m(t).overflow&&(e=n[gt]<0||11<n[gt]?gt:n[vt]<1||n[vt]>It(n[yt],n[gt])?vt:n[wt]<0||24<n[wt]||24===n[wt]&&(0!==n[bt]||0!==n[St]||0!==n[Dt])?wt:n[bt]<0||59<n[bt]?bt:n[St]<0||59<n[St]?St:n[Dt]<0||999<n[Dt]?Dt:-1,m(t)._overflowDayOfYear&&(e<yt||vt<e)&&(e=vt),m(t)._overflowWeeks&&-1===e&&(e=kt),m(t)._overflowWeekday&&-1===e&&(e=Mt),m(t).overflow=e),t}function ye(t,e,n){return null!=t?t:null!=e?e:n}function ge(t){var e,n,r,i,s,a=[];if(!t._d){for(r=function(t){var e=new Date(l.now());if(t._useUTC)return[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()];return[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[vt]&&null==t._a[gt]&&function(t){var e,n,r,i,s,a,o,u;if(null!=(e=t._w).GG||null!=e.W||null!=e.E)s=1,a=4,n=ye(e.GG,t._a[yt],qt(Ie(),1,4).year),r=ye(e.W,1),((i=ye(e.E,1))<1||7<i)&&(u=!0);else{s=t._locale._week.dow,a=t._locale._week.doy;var l=qt(Ie(),s,a);n=ye(e.gg,t._a[yt],l.year),r=ye(e.w,l.week),null!=e.d?((i=e.d)<0||6<i)&&(u=!0):null!=e.e?(i=e.e+s,(e.e<0||6<e.e)&&(u=!0)):i=s}r<1||r>zt(n,s,a)?m(t)._overflowWeeks=!0:null!=u?m(t)._overflowWeekday=!0:(o=Bt(n,r,i,s,a),t._a[yt]=o.year,t._dayOfYear=o.dayOfYear)}(t),null!=t._dayOfYear&&(s=ye(t._a[yt],r[yt]),(t._dayOfYear>Ot(s)||0===t._dayOfYear)&&(m(t)._overflowDayOfYear=!0),n=Gt(s,0,t._dayOfYear),t._a[gt]=n.getUTCMonth(),t._a[vt]=n.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=a[e]=r[e];for(;e<7;e++)t._a[e]=a[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[wt]&&0===t._a[bt]&&0===t._a[St]&&0===t._a[Dt]&&(t._nextDay=!0,t._a[wt]=0),t._d=(t._useUTC?Gt:function(t,e,n,r,i,s,a){var o;t<100&&0<=t?(o=new Date(t+400,e,n,r,i,s,a),isFinite(o.getFullYear())&&o.setFullYear(t)):o=new Date(t,e,n,r,i,s,a);return o}).apply(null,a),i=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[wt]=24),t._w&&void 0!==t._w.d&&t._w.d!==i&&(m(t).weekdayMismatch=!0)}}var ve=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,we=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,be=/Z|[+-]\d\d(?::?\d\d)?/,Se=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],De=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],ke=/^\/?Date\((\-?\d+)/i;function Me(t){var e,n,r,i,s,a,o=t._i,u=ve.exec(o)||we.exec(o);if(u){for(m(t).iso=!0,e=0,n=Se.length;e<n;e++)if(Se[e][1].exec(u[1])){i=Se[e][0],r=!1!==Se[e][2];break}if(null==i)return void(t._isValid=!1);if(u[3]){for(e=0,n=De.length;e<n;e++)if(De[e][1].exec(u[3])){s=(u[2]||" ")+De[e][0];break}if(null==s)return void(t._isValid=!1)}if(!r&&null!=s)return void(t._isValid=!1);if(u[4]){if(!be.exec(u[4]))return void(t._isValid=!1);a="Z"}t._f=i+(s||"")+(a||""),Pe(t)}else t._isValid=!1}var Oe=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function xe(t,e,n,r,i,s){var a=[function(t){var e=parseInt(t,10);{if(e<=49)return 2e3+e;if(e<=999)return 1900+e}return e}(t),jt.indexOf(e),parseInt(n,10),parseInt(r,10),parseInt(i,10)];return s&&a.push(parseInt(s,10)),a}var Ye={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Te(t){var e=Oe.exec(function(t){return t.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")}(t._i));if(e){var n=xe(e[4],e[3],e[2],e[5],e[6],e[7]);if(!function(t,e,n){if(t){var r=Qt.indexOf(t),i=new Date(e[0],e[1],e[2]).getDay();if(r!==i)return m(n).weekdayMismatch=!0,n._isValid=!1}return!0}(e[1],n,t))return;t._a=n,t._tzm=function(t,e,n){{if(t)return Ye[t];if(e)return 0;var r=parseInt(n,10),i=r%100;return 60*((r-i)/100)+i}}(e[8],e[9],e[10]),t._d=Gt.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),m(t).rfc2822=!0}else t._isValid=!1}function Pe(t){if(t._f!==l.ISO_8601)if(t._f!==l.RFC_2822){t._a=[],m(t).empty=!0;var e,n,r,i,s,a=""+t._i,o=a.length,u=0;for(r=q(t._f,t._locale).match(W)||[],e=0;e<r.length;e++)i=r[e],(n=(a.match(dt(i,t))||[])[0])&&(0<(s=a.substr(0,a.indexOf(n))).length&&m(t).unusedInput.push(s),a=a.slice(a.indexOf(n)+n.length),u+=n.length),F[i]?(n?m(t).empty=!1:m(t).unusedTokens.push(i),pt(i,n,t)):t._strict&&!n&&m(t).unusedTokens.push(i);m(t).charsLeftOver=o-u,0<a.length&&m(t).unusedInput.push(a),t._a[wt]<=12&&!0===m(t).bigHour&&0<t._a[wt]&&(m(t).bigHour=void 0),m(t).parsedDateParts=t._a.slice(0),m(t).meridiem=t._meridiem,t._a[wt]=function(t,e,n){var r;if(null==n)return e;return null!=t.meridiemHour?t.meridiemHour(e,n):(null!=t.isPM&&((r=t.isPM(n))&&e<12&&(e+=12),r||12!==e||(e=0)),e)}(t._locale,t._a[wt],t._meridiem),ge(t),pe(t)}else Te(t);else Me(t)}function Ce(t){var e=t._i,n=t._f;return t._locale=t._locale||_e(t._l),null===e||void 0===n&&""===e?p({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),w(e)?new v(pe(e)):(h(e)?t._d=e:a(n)?function(t){var e,n,r,i,s;if(0===t._f.length)return m(t).invalidFormat=!0,t._d=new Date(NaN);for(i=0;i<t._f.length;i++)s=0,e=g({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[i],Pe(e),_(e)&&(s+=m(e).charsLeftOver,s+=10*m(e).unusedTokens.length,m(e).score=s,(null==r||s<r)&&(r=s,n=e));f(t,n||e)}(t):n?Pe(t):function(t){var e=t._i;s(e)?t._d=new Date(l.now()):h(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=ke.exec(t._i);if(null!==e)return t._d=new Date(+e[1]);{if(Me(t),!1!==t._isValid)return;delete t._isValid}{if(Te(t),!1!==t._isValid)return;delete t._isValid}l.createFromInputFallback(t)}(t):a(e)?(t._a=r(e.slice(0),function(t){return parseInt(t,10)}),ge(t)):o(e)?function(t){if(t._d)return;var e=A(t._i);t._a=r([e.year,e.month,e.day||e.date,e.hour,e.minute,e.second,e.millisecond],function(t){return t&&parseInt(t,10)}),ge(t)}(t):u(e)?t._d=new Date(e):l.createFromInputFallback(t)}(t),_(t)||(t._d=null),t))}function Ee(t,e,n,r,i){var s={};return!0!==n&&!1!==n||(r=n,n=void 0),(o(t)&&function(t){{if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(t.hasOwnProperty(e))return!1;return!0}}(t)||a(t)&&0===t.length)&&(t=void 0),s._isAMomentObject=!0,s._useUTC=s._isUTC=i,s._l=n,s._i=t,s._f=e,s._strict=r,function(t){var e=new v(pe(Ce(t)));e._nextDay&&(e.add(1,"d"),e._nextDay=void 0);return e}(s)}function Ie(t,e,n,r){return Ee(t,e,n,r,!1)}l.createFromInputFallback=t("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))}),l.ISO_8601=function(){},l.RFC_2822=function(){};var Ae=t("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",function(){var t=Ie.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:p()}),Ne=t("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",function(){var t=Ie.apply(null,arguments);return this.isValid()&&t.isValid()?this<t?this:t:p()});function je(t,e){var n,r;if(1===e.length&&a(e[0])&&(e=e[0]),!e.length)return Ie();for(n=e[0],r=1;r<e.length;++r)e[r].isValid()&&!e[r][t](n)||(n=e[r]);return n}var Re=["year","quarter","month","week","day","hour","minute","second","millisecond"];function He(t){var e=A(t),n=e.year||0,r=e.quarter||0,i=e.month||0,s=e.week||e.isoWeek||0,a=e.day||0,o=e.hour||0,u=e.minute||0,l=e.second||0,h=e.millisecond||0;this._isValid=function(t){for(var e in t)if(-1===Yt.call(Re,e)||null!=t[e]&&isNaN(t[e]))return!1;for(var n=!1,r=0;r<Re.length;++r)if(t[Re[r]]){if(n)return!1;parseFloat(t[Re[r]])!==S(t[Re[r]])&&(n=!0)}return!0}(e),this._milliseconds=+h+1e3*l+6e4*u+1e3*o*60*60,this._days=+a+7*s,this._months=+i+3*r+12*n,this._data={},this._locale=_e(),this._bubble()}function We(t){return t instanceof He}function Ve(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function Ue(t,n){G(t,0,0,function(){var t=this.utcOffset(),e="+";return t<0&&(t=-t,e="-"),e+H(~~(t/60),2)+n+H(~~t%60,2)})}Ue("Z",":"),Ue("ZZ",""),ht("Z",ot),ht("ZZ",ot),mt(["Z","ZZ"],function(t,e,n){n._useUTC=!0,n._tzm=Ge(ot,t)});var Fe=/([\+\-]|\d\d)/gi;function Ge(t,e){var n=(e||"").match(t);if(null===n)return null;var r=n[n.length-1]||[],i=(r+"").match(Fe)||["-",0,0],s=60*i[1]+S(i[2]);return 0===s?0:"+"===i[0]?s:-s}function Le(t,e){var n,r;return e._isUTC?(n=e.clone(),r=(w(t)||h(t)?t.valueOf():Ie(t).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+r),l.updateOffset(n,!1),n):Ie(t).local()}function Be(t){return 15*-Math.round(t._d.getTimezoneOffset()/15)}function qe(){return!!this.isValid()&&(this._isUTC&&0===this._offset)}l.updateOffset=function(){};var ze=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Ze=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function $e(t,e){var n,r,i,s=t,a=null;return We(t)?s={ms:t._milliseconds,d:t._days,M:t._months}:u(t)?(s={},e?s[e]=t:s.milliseconds=t):(a=ze.exec(t))?(n="-"===a[1]?-1:1,s={y:0,d:S(a[vt])*n,h:S(a[wt])*n,m:S(a[bt])*n,s:S(a[St])*n,ms:S(Ve(1e3*a[Dt]))*n}):(a=Ze.exec(t))?(n="-"===a[1]?-1:1,s={y:Qe(a[2],n),M:Qe(a[3],n),w:Qe(a[4],n),d:Qe(a[5],n),h:Qe(a[6],n),m:Qe(a[7],n),s:Qe(a[8],n)}):null==s?s={}:"object"==typeof s&&("from"in s||"to"in s)&&(i=function(t,e){var n;if(!t.isValid()||!e.isValid())return{milliseconds:0,months:0};e=Le(e,t),t.isBefore(e)?n=Je(t,e):((n=Je(e,t)).milliseconds=-n.milliseconds,n.months=-n.months);return n}(Ie(s.from),Ie(s.to)),(s={}).ms=i.milliseconds,s.M=i.months),r=new He(s),We(t)&&d(t,"_locale")&&(r._locale=t._locale),r}function Qe(t,e){var n=t&&parseFloat(t.replace(",","."));return(isNaN(n)?0:n)*e}function Je(t,e){var n={};return n.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(n.months,"M").isAfter(e)&&--n.months,n.milliseconds=+e-+t.clone().add(n.months,"M"),n}function Xe(r,i){return function(t,e){var n;return null===e||isNaN(+e)||(x(i,"moment()."+i+"(period, number) is deprecated. Please use moment()."+i+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),n=t,t=e,e=n),Ke(this,$e(t="string"==typeof t?+t:t,e),r),this}}function Ke(t,e,n,r){var i=e._milliseconds,s=Ve(e._days),a=Ve(e._months);t.isValid()&&(r=null==r||r,a&&Ht(t,Ct(t,"Month")+a*n),s&&Et(t,"Date",Ct(t,"Date")+s*n),i&&t._d.setTime(t._d.valueOf()+i*n),r&&l.updateOffset(t,s||a))}$e.fn=He.prototype,$e.invalid=function(){return $e(NaN)};var tn=Xe(1,"add"),en=Xe(-1,"subtract");function nn(t,e){var n,r,i=12*(e.year()-t.year())+(e.month()-t.month()),s=t.clone().add(i,"months");return r=e-s<0?(n=t.clone().add(i-1,"months"),(e-s)/(s-n)):(n=t.clone().add(1+i,"months"),(e-s)/(n-s)),-(i+r)||0}function rn(t){var e;return void 0===t?this._locale._abbr:(null!=(e=_e(t))&&(this._locale=e),this)}l.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",l.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var sn=t("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",function(t){return void 0===t?this.localeData():this.locale(t)});function an(){return this._locale}var on=126227808e5;function un(t,e){return(t%e+e)%e}function ln(t,e,n){return t<100&&0<=t?new Date(t+400,e,n)-on:new Date(t,e,n).valueOf()}function hn(t,e,n){return t<100&&0<=t?Date.UTC(t+400,e,n)-on:Date.UTC(t,e,n)}function dn(t,e){G(0,[t,t.length],0,e)}function fn(t,e,n,r,i){var s;return null==t?qt(this,r,i).year:((s=zt(t,r,i))<e&&(e=s),function(t,e,n,r,i){var s=Bt(t,e,n,r,i),a=Gt(s.year,0,s.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}.call(this,t,e,n,r,i))}G(0,["gg",2],0,function(){return this.weekYear()%100}),G(0,["GG",2],0,function(){return this.isoWeekYear()%100}),dn("gggg","weekYear"),dn("ggggg","weekYear"),dn("GGGG","isoWeekYear"),dn("GGGGG","isoWeekYear"),E("weekYear","gg"),E("isoWeekYear","GG"),j("weekYear",1),j("isoWeekYear",1),ht("G",st),ht("g",st),ht("GG",X,Z),ht("gg",X,Z),ht("GGGG",nt,Q),ht("gggg",nt,Q),ht("GGGGG",rt,J),ht("ggggg",rt,J),_t(["gggg","ggggg","GGGG","GGGGG"],function(t,e,n,r){e[r.substr(0,2)]=S(t)}),_t(["gg","GG"],function(t,e,n,r){e[r]=l.parseTwoDigitYear(t)}),G("Q",0,"Qo","quarter"),E("quarter","Q"),j("quarter",7),ht("Q",z),mt("Q",function(t,e){e[gt]=3*(S(t)-1)}),G("D",["DD",2],"Do","date"),E("date","D"),j("date",9),ht("D",X),ht("DD",X,Z),ht("Do",function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient}),mt(["D","DD"],vt),mt("Do",function(t,e){e[vt]=S(t.match(X)[0])});var cn=Pt("Date",!0);G("DDD",["DDDD",3],"DDDo","dayOfYear"),E("dayOfYear","DDD"),j("dayOfYear",4),ht("DDD",et),ht("DDDD",$),mt(["DDD","DDDD"],function(t,e,n){n._dayOfYear=S(t)}),G("m",["mm",2],0,"minute"),E("minute","m"),j("minute",14),ht("m",X),ht("mm",X,Z),mt(["m","mm"],bt);var mn=Pt("Minutes",!1);G("s",["ss",2],0,"second"),E("second","s"),j("second",15),ht("s",X),ht("ss",X,Z),mt(["s","ss"],St);var _n,pn=Pt("Seconds",!1);for(G("S",0,0,function(){return~~(this.millisecond()/100)}),G(0,["SS",2],0,function(){return~~(this.millisecond()/10)}),G(0,["SSS",3],0,"millisecond"),G(0,["SSSS",4],0,function(){return 10*this.millisecond()}),G(0,["SSSSS",5],0,function(){return 100*this.millisecond()}),G(0,["SSSSSS",6],0,function(){return 1e3*this.millisecond()}),G(0,["SSSSSSS",7],0,function(){return 1e4*this.millisecond()}),G(0,["SSSSSSSS",8],0,function(){return 1e5*this.millisecond()}),G(0,["SSSSSSSSS",9],0,function(){return 1e6*this.millisecond()}),E("millisecond","ms"),j("millisecond",16),ht("S",et,z),ht("SS",et,Z),ht("SSS",et,$),_n="SSSS";_n.length<=9;_n+="S")ht(_n,it);function yn(t,e){e[Dt]=S(1e3*("0."+t))}for(_n="S";_n.length<=9;_n+="S")mt(_n,yn);var gn=Pt("Milliseconds",!1);G("z",0,0,"zoneAbbr"),G("zz",0,0,"zoneName");var vn=v.prototype;function wn(t){return t}vn.add=tn,vn.calendar=function(t,e){var n=t||Ie(),r=Le(n,this).startOf("day"),i=l.calendarFormat(this,r)||"sameElse",s=e&&(Y(e[i])?e[i].call(this,n):e[i]);return this.format(s||this.localeData().calendar(i,this,Ie(n)))},vn.clone=function(){return new v(this)},vn.diff=function(t,e,n){var r,i,s;if(!this.isValid())return NaN;if(!(r=Le(t,this)).isValid())return NaN;switch(i=6e4*(r.utcOffset()-this.utcOffset()),e=I(e)){case"year":s=nn(this,r)/12;break;case"month":s=nn(this,r);break;case"quarter":s=nn(this,r)/3;break;case"second":s=(this-r)/1e3;break;case"minute":s=(this-r)/6e4;break;case"hour":s=(this-r)/36e5;break;case"day":s=(this-r-i)/864e5;break;case"week":s=(this-r-i)/6048e5;break;default:s=this-r}return n?s:b(s)},vn.endOf=function(t){var e;if(void 0===(t=I(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?hn:ln;switch(t){case"year":e=n(this.year()+1,0,1)-1;break;case"quarter":e=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=n(this.year(),this.month()+1,1)-1;break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=36e5-un(e+(this._isUTC?0:6e4*this.utcOffset()),36e5)-1;break;case"minute":e=this._d.valueOf(),e+=6e4-un(e,6e4)-1;break;case"second":e=this._d.valueOf(),e+=1e3-un(e,1e3)-1}return this._d.setTime(e),l.updateOffset(this,!0),this},vn.format=function(t){t=t||(this.isUtc()?l.defaultFormatUtc:l.defaultFormat);var e=B(this,t);return this.localeData().postformat(e)},vn.from=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ie(t).isValid())?$e({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},vn.fromNow=function(t){return this.from(Ie(),t)},vn.to=function(t,e){return this.isValid()&&(w(t)&&t.isValid()||Ie(t).isValid())?$e({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},vn.toNow=function(t){return this.to(Ie(),t)},vn.get=function(t){if(Y(this[t=I(t)]))return this[t]();return this},vn.invalidAt=function(){return m(this).overflow},vn.isAfter=function(t,e){var n=w(t)?t:Ie(t);if(!this.isValid()||!n.isValid())return!1;return"millisecond"===(e=I(e)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(e).valueOf()},vn.isBefore=function(t,e){var n=w(t)?t:Ie(t);if(!this.isValid()||!n.isValid())return!1;return"millisecond"===(e=I(e)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(e).valueOf()<n.valueOf()},vn.isBetween=function(t,e,n,r){var i=w(t)?t:Ie(t),s=w(e)?e:Ie(e);return!!(this.isValid()&&i.isValid()&&s.isValid())&&(("("===(r=r||"()")[0]?this.isAfter(i,n):!this.isBefore(i,n))&&(")"===r[1]?this.isBefore(s,n):!this.isAfter(s,n)))},vn.isSame=function(t,e){var n,r=w(t)?t:Ie(t);if(!this.isValid()||!r.isValid())return!1;return"millisecond"===(e=I(e)||"millisecond")?this.valueOf()===r.valueOf():(n=r.valueOf(),this.clone().startOf(e).valueOf()<=n&&n<=this.clone().endOf(e).valueOf())},vn.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},vn.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},vn.isValid=function(){return _(this)},vn.lang=sn,vn.locale=rn,vn.localeData=an,vn.max=Ne,vn.min=Ae,vn.parsingFlags=function(){return f({},m(this))},vn.set=function(t,e){if("object"==typeof t)for(var n=R(t=A(t)),r=0;r<n.length;r++)this[n[r].unit](t[n[r].unit]);else if(Y(this[t=I(t)]))return this[t](e);return this},vn.startOf=function(t){var e;if(void 0===(t=I(t))||"millisecond"===t||!this.isValid())return this;var n=this._isUTC?hn:ln;switch(t){case"year":e=n(this.year(),0,1);break;case"quarter":e=n(this.year(),this.month()-this.month()%3,1);break;case"month":e=n(this.year(),this.month(),1);break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=n(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=un(e+(this._isUTC?0:6e4*this.utcOffset()),36e5);break;case"minute":e=this._d.valueOf(),e-=un(e,6e4);break;case"second":e=this._d.valueOf(),e-=un(e,1e3)}return this._d.setTime(e),l.updateOffset(this,!0),this},vn.subtract=en,vn.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},vn.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},vn.toDate=function(){return new Date(this.valueOf())},vn.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,n=e?this.clone().utc():this;if(n.year()<0||9999<n.year())return B(n,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ");if(Y(Date.prototype.toISOString))return e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",B(n,"Z"));return B(n,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},vn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t="moment",e="";this.isLocal()||(t=0===this.utcOffset()?"moment.utc":"moment.parseZone",e="Z");var n="["+t+'("]',r=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",i=e+'[")]';return this.format(n+r+"-MM-DD[T]HH:mm:ss.SSS"+i)},vn.toJSON=function(){return this.isValid()?this.toISOString():null},vn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},vn.unix=function(){return Math.floor(this.valueOf()/1e3)},vn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},vn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},vn.year=Tt,vn.isLeapYear=function(){return xt(this.year())},vn.weekYear=function(t){return fn.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},vn.isoWeekYear=function(t){return fn.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},vn.quarter=vn.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},vn.month=Wt,vn.daysInMonth=function(){return It(this.year(),this.month())},vn.week=vn.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},vn.isoWeek=vn.isoWeeks=function(t){var e=qt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},vn.weeksInYear=function(){var t=this.localeData()._week;return zt(this.year(),t.dow,t.doy)},vn.isoWeeksInYear=function(){return zt(this.year(),1,4)},vn.date=cn,vn.day=vn.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(n=t,r=this.localeData(),t="string"==typeof n?isNaN(n)?"number"!=typeof(n=r.weekdaysParse(n))?null:n:parseInt(n,10):n,this.add(t-e,"d")):e;var n,r},vn.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},vn.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;{if(null==t)return this.day()||7;var e=(n=t,r=this.localeData(),"string"!=typeof n?isNaN(n)?null:n:r.weekdaysParse(n)%7||7);return this.day(this.day()%7?e:e-7)}var n,r},vn.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},vn.hour=vn.hours=oe,vn.minute=vn.minutes=mn,vn.second=vn.seconds=pn,vn.millisecond=vn.milliseconds=gn,vn.utcOffset=function(t,e,n){var r,i=this._offset||0;if(!this.isValid())return null!=t?this:NaN;{if(null==t)return this._isUTC?i:Be(this);if("string"==typeof t){if(null===(t=Ge(ot,t)))return this}else Math.abs(t)<16&&!n&&(t*=60);return!this._isUTC&&e&&(r=Be(this)),this._offset=t,this._isUTC=!0,null!=r&&this.add(r,"m"),i!==t&&(!e||this._changeInProgress?Ke(this,$e(t-i,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,l.updateOffset(this,!0),this._changeInProgress=null)),this}},vn.utc=function(t){return this.utcOffset(0,t)},vn.local=function(t){this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Be(this),"m"));return this},vn.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ge(at,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},vn.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Ie(t).utcOffset():0,(this.utcOffset()-t)%60==0)},vn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},vn.isLocal=function(){return!!this.isValid()&&!this._isUTC},vn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},vn.isUtc=qe,vn.isUTC=qe,vn.zoneAbbr=function(){return this._isUTC?"UTC":""},vn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},vn.dates=t("dates accessor is deprecated. Use date instead.",cn),vn.months=t("months accessor is deprecated. Use month instead",Wt),vn.years=t("years accessor is deprecated. Use year instead",Tt),vn.zone=t("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()}),vn.isDSTShifted=t("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",function(){if(!s(this._isDSTShifted))return this._isDSTShifted;var t={};if(g(t,this),(t=Ce(t))._a){var e=t._isUTC?c(t._a):Ie(t._a);this._isDSTShifted=this.isValid()&&0<D(t._a,e.toArray())}else this._isDSTShifted=!1;return this._isDSTShifted});var bn=P.prototype;function Sn(t,e,n,r){var i=_e(),s=c().set(r,e);return i[n](s,t)}function Dn(t,e,n){if(u(t)&&(e=t,t=void 0),t=t||"",null!=e)return Sn(t,e,n,"month");var r,i=[];for(r=0;r<12;r++)i[r]=Sn(t,r,n,"month");return i}function kn(t,e,n,r){e=("boolean"==typeof t?u(e)&&(n=e,e=void 0):(e=t,t=!1,u(n=e)&&(n=e,e=void 0)),e||"");var i,s=_e(),a=t?s._week.dow:0;if(null!=n)return Sn(e,(n+a)%7,r,"day");var o=[];for(i=0;i<7;i++)o[i]=Sn(e,(i+a)%7,r,"day");return o}bn.calendar=function(t,e,n){var r=this._calendar[t]||this._calendar.sameElse;return Y(r)?r.call(e,n):r},bn.longDateFormat=function(t){var e=this._longDateFormat[t],n=this._longDateFormat[t.toUpperCase()];return!e&&n?(this._longDateFormat[t]=n.replace(/MMMM|MM|DD|dddd/g,function(t){return t.slice(1)}),this._longDateFormat[t]):e},bn.invalidDate=function(){return this._invalidDate},bn.ordinal=function(t){return this._ordinal.replace("%d",t)},bn.preparse=wn,bn.postformat=wn,bn.relativeTime=function(t,e,n,r){var i=this._relativeTime[n];return Y(i)?i(t,e,n,r):i.replace(/%d/i,t)},bn.pastFuture=function(t,e){var n=this._relativeTime[0<t?"future":"past"];return Y(n)?n(e):n.replace(/%s/i,e)},bn.set=function(t){var e,n;for(n in t)Y(e=t[n])?this[n]=e:this["_"+n]=e;this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},bn.months=function(t,e){return t?a(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||At).test(e)?"format":"standalone"][t.month()]:a(this._months)?this._months:this._months.standalone},bn.monthsShort=function(t,e){return t?a(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[At.test(e)?"format":"standalone"][t.month()]:a(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},bn.monthsParse=function(t,e,n){var r,i,s;if(this._monthsParseExact)return Rt.call(this,t,e,n);this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]);for(r=0;r<12;r++){if(i=c([2e3,r]),n&&!this._longMonthsParse[r]&&(this._longMonthsParse[r]=new RegExp("^"+this.months(i,"").replace(".","")+"$","i"),this._shortMonthsParse[r]=new RegExp("^"+this.monthsShort(i,"").replace(".","")+"$","i")),n||this._monthsParse[r]||(s="^"+this.months(i,"")+"|^"+this.monthsShort(i,""),this._monthsParse[r]=new RegExp(s.replace(".",""),"i")),n&&"MMMM"===e&&this._longMonthsParse[r].test(t))return r;if(n&&"MMM"===e&&this._shortMonthsParse[r].test(t))return r;if(!n&&this._monthsParse[r].test(t))return r}},bn.monthsRegex=function(t){return this._monthsParseExact?(d(this,"_monthsRegex")||Ft.call(this),t?this._monthsStrictRegex:this._monthsRegex):(d(this,"_monthsRegex")||(this._monthsRegex=Ut),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},bn.monthsShortRegex=function(t){return this._monthsParseExact?(d(this,"_monthsRegex")||Ft.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(d(this,"_monthsShortRegex")||(this._monthsShortRegex=Vt),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},bn.week=function(t){return qt(t,this._week.dow,this._week.doy).week},bn.firstDayOfYear=function(){return this._week.doy},bn.firstDayOfWeek=function(){return this._week.dow},bn.weekdays=function(t,e){var n=a(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Zt(n,this._week.dow):t?n[t.day()]:n},bn.weekdaysMin=function(t){return!0===t?Zt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},bn.weekdaysShort=function(t){return!0===t?Zt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},bn.weekdaysParse=function(t,e,n){var r,i,s;if(this._weekdaysParseExact)return Xt.call(this,t,e,n);this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]);for(r=0;r<7;r++){if(i=c([2e3,1]).day(r),n&&!this._fullWeekdaysParse[r]&&(this._fullWeekdaysParse[r]=new RegExp("^"+this.weekdays(i,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[r]=new RegExp("^"+this.weekdaysShort(i,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[r]=new RegExp("^"+this.weekdaysMin(i,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[r]||(s="^"+this.weekdays(i,"")+"|^"+this.weekdaysShort(i,"")+"|^"+this.weekdaysMin(i,""),this._weekdaysParse[r]=new RegExp(s.replace(".",""),"i")),n&&"dddd"===e&&this._fullWeekdaysParse[r].test(t))return r;if(n&&"ddd"===e&&this._shortWeekdaysParse[r].test(t))return r;if(n&&"dd"===e&&this._minWeekdaysParse[r].test(t))return r;if(!n&&this._weekdaysParse[r].test(t))return r}},bn.weekdaysRegex=function(t){return this._weekdaysParseExact?(d(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(d(this,"_weekdaysRegex")||(this._weekdaysRegex=Kt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},bn.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(d(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(d(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=te),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},bn.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(d(this,"_weekdaysRegex")||ne.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(d(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=ee),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},bn.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},bn.meridiem=function(t,e,n){return 11<t?n?"pm":"PM":n?"am":"AM"},ce("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10,n=1===S(t%100/10)?"th":1==e?"st":2==e?"nd":3==e?"rd":"th";return t+n}}),l.lang=t("moment.lang is deprecated. Use moment.locale instead.",ce),l.langData=t("moment.langData is deprecated. Use moment.localeData instead.",_e);var Mn=Math.abs;function On(t,e,n,r){var i=$e(e,n);return t._milliseconds+=r*i._milliseconds,t._days+=r*i._days,t._months+=r*i._months,t._bubble()}function xn(t){return t<0?Math.floor(t):Math.ceil(t)}function Yn(t){return 4800*t/146097}function Tn(t){return 146097*t/4800}function Pn(t){return function(){return this.as(t)}}var Cn=Pn("ms"),En=Pn("s"),In=Pn("m"),An=Pn("h"),Nn=Pn("d"),jn=Pn("w"),Rn=Pn("M"),Hn=Pn("Q"),Wn=Pn("y");function Vn(t){return function(){return this.isValid()?this._data[t]:NaN}}var Un=Vn("milliseconds"),Fn=Vn("seconds"),Gn=Vn("minutes"),Ln=Vn("hours"),Bn=Vn("days"),qn=Vn("months"),zn=Vn("years");var Zn=Math.round,$n={ss:44,s:45,m:45,h:22,d:26,M:11};var Qn=Math.abs;function Jn(t){return(0<t)-(t<0)||+t}function Xn(){if(!this.isValid())return this.localeData().invalidDate();var t,e,n=Qn(this._milliseconds)/1e3,r=Qn(this._days),i=Qn(this._months);t=b(n/60),e=b(t/60),n%=60,t%=60;var s=b(i/12),a=i%=12,o=r,u=e,l=t,h=n?n.toFixed(3).replace(/\.?0+$/,""):"",d=this.asSeconds();if(!d)return"P0D";var f=d<0?"-":"",c=Jn(this._months)!==Jn(d)?"-":"",m=Jn(this._days)!==Jn(d)?"-":"",_=Jn(this._milliseconds)!==Jn(d)?"-":"";return f+"P"+(s?c+s+"Y":"")+(a?c+a+"M":"")+(o?m+o+"D":"")+(u||l||h?"T":"")+(u?_+u+"H":"")+(l?_+l+"M":"")+(h?_+h+"S":"")}var Kn=He.prototype;return Kn.isValid=function(){return this._isValid},Kn.abs=function(){var t=this._data;return this._milliseconds=Mn(this._milliseconds),this._days=Mn(this._days),this._months=Mn(this._months),t.milliseconds=Mn(t.milliseconds),t.seconds=Mn(t.seconds),t.minutes=Mn(t.minutes),t.hours=Mn(t.hours),t.months=Mn(t.months),t.years=Mn(t.years),this},Kn.add=function(t,e){return On(this,t,e,1)},Kn.subtract=function(t,e){return On(this,t,e,-1)},Kn.as=function(t){if(!this.isValid())return NaN;var e,n,r=this._milliseconds;if("month"===(t=I(t))||"quarter"===t||"year"===t)switch(e=this._days+r/864e5,n=this._months+Yn(e),t){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(e=this._days+Math.round(Tn(this._months)),t){case"week":return e/7+r/6048e5;case"day":return e+r/864e5;case"hour":return 24*e+r/36e5;case"minute":return 1440*e+r/6e4;case"second":return 86400*e+r/1e3;case"millisecond":return Math.floor(864e5*e)+r;default:throw new Error("Unknown unit "+t)}},Kn.asMilliseconds=Cn,Kn.asSeconds=En,Kn.asMinutes=In,Kn.asHours=An,Kn.asDays=Nn,Kn.asWeeks=jn,Kn.asMonths=Rn,Kn.asQuarters=Hn,Kn.asYears=Wn,Kn.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*S(this._months/12):NaN},Kn._bubble=function(){var t,e,n,r,i,s=this._milliseconds,a=this._days,o=this._months,u=this._data;return 0<=s&&0<=a&&0<=o||s<=0&&a<=0&&o<=0||(s+=864e5*xn(Tn(o)+a),o=a=0),u.milliseconds=s%1e3,t=b(s/1e3),u.seconds=t%60,e=b(t/60),u.minutes=e%60,n=b(e/60),u.hours=n%24,a+=b(n/24),i=b(Yn(a)),o+=i,a-=xn(Tn(i)),r=b(o/12),o%=12,u.days=a,u.months=o,u.years=r,this},Kn.clone=function(){return $e(this)},Kn.get=function(t){return t=I(t),this.isValid()?this[t+"s"]():NaN},Kn.milliseconds=Un,Kn.seconds=Fn,Kn.minutes=Gn,Kn.hours=Ln,Kn.days=Bn,Kn.weeks=function(){return b(this.days()/7)},Kn.months=qn,Kn.years=zn,Kn.humanize=function(t){if(!this.isValid())return this.localeData().invalidDate();var e=this.localeData(),n=function(t,e,n){var r=$e(t).abs(),i=Zn(r.as("s")),s=Zn(r.as("m")),a=Zn(r.as("h")),o=Zn(r.as("d")),u=Zn(r.as("M")),l=Zn(r.as("y")),h=i<=$n.ss&&["s",i]||i<$n.s&&["ss",i]||s<=1&&["m"]||s<$n.m&&["mm",s]||a<=1&&["h"]||a<$n.h&&["hh",a]||o<=1&&["d"]||o<$n.d&&["dd",o]||u<=1&&["M"]||u<$n.M&&["MM",u]||l<=1&&["y"]||["yy",l];return h[2]=e,h[3]=0<+t,h[4]=n,function(t,e,n,r,i){return i.relativeTime(e||1,!!n,t,r)}.apply(null,h)}(this,!t,e);return t&&(n=e.pastFuture(+this,n)),e.postformat(n)},Kn.toISOString=Xn,Kn.toString=Xn,Kn.toJSON=Xn,Kn.locale=rn,Kn.localeData=an,Kn.toIsoString=t("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",Xn),Kn.lang=sn,G("X",0,0,"unix"),G("x",0,0,"valueOf"),ht("x",st),ht("X",/[+-]?\d+(\.\d{1,3})?/),mt("X",function(t,e,n){n._d=new Date(1e3*parseFloat(t,10))}),mt("x",function(t,e,n){n._d=new Date(S(t))}),l.version="2.24.0",function(t){e=t}(Ie),l.fn=vn,l.min=function(){return je("isBefore",[].slice.call(arguments,0))},l.max=function(){return je("isAfter",[].slice.call(arguments,0))},l.now=function(){return Date.now?Date.now():+new Date},l.utc=c,l.unix=function(t){return Ie(1e3*t)},l.months=function(t,e){return Dn(t,e,"months")},l.isDate=h,l.locale=ce,l.invalid=p,l.duration=$e,l.isMoment=w,l.weekdays=function(t,e,n){return kn(t,e,n,"weekdays")},l.parseZone=function(){return Ie.apply(null,arguments).parseZone()},l.localeData=_e,l.isDuration=We,l.monthsShort=function(t,e){return Dn(t,e,"monthsShort")},l.weekdaysMin=function(t,e,n){return kn(t,e,n,"weekdaysMin")},l.defineLocale=me,l.updateLocale=function(t,e){if(null!=e){var n,r,i=ue;null!=(r=fe(t))&&(i=r._config),e=T(i,e),(n=new P(e)).parentLocale=le[t],le[t]=n,ce(t)}else null!=le[t]&&(null!=le[t].parentLocale?le[t]=le[t].parentLocale:null!=le[t]&&delete le[t]);return le[t]},l.locales=function(){return M(le)},l.weekdaysShort=function(t,e,n){return kn(t,e,n,"weekdaysShort")},l.normalizeUnits=I,l.relativeTimeRounding=function(t){return void 0!==t?"function"==typeof t&&(Zn=t,!0):Zn},l.relativeTimeThreshold=function(t,e){return void 0!==$n[t]&&(void 0===e?$n[t]:($n[t]=e,"s"===t&&($n.ss=e-1),!0))},l.calendarFormat=function(t,e){var n=t.diff(e,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},l.prototype=vn,l.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},l}()}),s=[],a={},n=0;n<256;n++)s[n]=(n+256).toString(16).substr(1),a[s[n]]=n;function c(t,e){var n=e||0,r=s;return r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+"-"+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]+r[t[n++]]}for(var o=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var t=new Uint8Array(16);return function(){return crypto.getRandomValues(t),t}}var n=new Array(16);return function(){for(var t,e=0;e<16;e++)0==(3&e)&&(t=4294967296*Math.random()),n[e]=t>>>((3&e)<<3)&255;return n}}(),r=[],u=0;u<256;u++)r[u]=(u+256).toString(16).substr(1);var l=o(),m=[1|l[0],l[1],l[2],l[3],l[4],l[5]],_=16383&(l[6]<<8|l[7]),p=0,y=0;function h(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e=1<arguments.length?arguments[1]:void 0,n=e&&(2<arguments.length?arguments[2]:void 0)||0;"string"==typeof t&&(e="binary"===t?new Array(16):void 0,t={});var r=t.random||(t.rng||o)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,e)for(var i=0;i<16;i++)e[n+i]=r[i];return e||c(r)}function d(){return h.apply(void 0,arguments)}d.v1=function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e=1<arguments.length?arguments[1]:void 0,n=e&&(2<arguments.length?arguments[2]:void 0)||0,r=e||[],i=void 0!==t.clockseq?t.clockseq:_,s=void 0!==t.msecs?t.msecs:(new Date).getTime(),a=void 0!==t.nsecs?t.nsecs:y+1,o=s-p+(a-y)/1e4;if(o<0&&void 0===t.clockseq&&(i=i+1&16383),(o<0||p<s)&&void 0===t.nsecs&&(a=0),1e4<=a)throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");p=s,_=i;var u=(1e4*(268435455&(s+=122192928e5))+(y=a))%4294967296;r[n++]=u>>>24&255,r[n++]=u>>>16&255,r[n++]=u>>>8&255,r[n++]=255&u;var l=s/4294967296*1e4&268435455;r[n++]=l>>>8&255,r[n++]=255&l,r[n++]=l>>>24&15|16,r[n++]=l>>>16&255,r[n++]=i>>>8|128,r[n++]=255&i;for(var h=t.node||m,d=0;d<6;d++)r[n+d]=h[d];return e||c(r)},d.v4=h,d.parse=function(t){var e=1<arguments.length&&void 0!==arguments[1]?arguments[1]:[],n=e&&(2<arguments.length?arguments[2]:void 0)||0,r=0;for(t.toLowerCase().replace(/[0-9a-f]{2}/g,function(t){return r<16&&(e[n+r++]=a[t]),""});r<16;)e[n+r++]=0;return e},d.unparse=c;var g=e(function(t,u){function h(t){return(h="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function a(t,e,n,r){var i=!1;!0===r&&(i=null===e[n]&&void 0!==t[n]),i?delete t[n]:t[n]=e[n]}u.isNumber=function(t){return t instanceof Number||"number"==typeof t},u.recursiveDOMDelete=function(t){if(t)for(;!0===t.hasChildNodes();)u.recursiveDOMDelete(t.firstChild),t.removeChild(t.firstChild)},u.isString=function(t){return t instanceof String||"string"==typeof t},u.isDate=function(t){if(t instanceof Date)return!0;if(u.isString(t)){if(r.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},u.randomUUID=function(){return d.v4()},u.fillIfDefined=function(t,e){var n=2<arguments.length&&void 0!==arguments[2]&&arguments[2];for(var r in t)void 0!==e[r]&&(null===e[r]||"object"!==h(e[r])?a(t,e,r,n):"object"===h(t[r])&&u.fillIfDefined(t[r],e[r],n))},u.extend=function(t,e){for(var n=1;n<arguments.length;n++){var r=arguments[n];for(var i in r)r.hasOwnProperty(i)&&(t[i]=r[i])}return t},u.selectiveExtend=function(t,e,n){if(!Array.isArray(t))throw new Error("Array with property names expected as first argument");for(var r=2;r<arguments.length;r++)for(var i=arguments[r],s=0;s<t.length;s++){var a=t[s];i&&i.hasOwnProperty(a)&&(e[a]=i[a])}return e},u.selectiveDeepExtend=function(t,e,n){var r=3<arguments.length&&void 0!==arguments[3]&&arguments[3];if(Array.isArray(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var s=t[i];if(n.hasOwnProperty(s))if(n[s]&&n[s].constructor===Object)void 0===e[s]&&(e[s]={}),e[s].constructor===Object?u.deepExtend(e[s],n[s],!1,r):a(e,n,s,r);else{if(Array.isArray(n[s]))throw new TypeError("Arrays are not supported by deepExtend");a(e,n,s,r)}}return e},u.selectiveNotDeepExtend=function(t,e,n){var r=3<arguments.length&&void 0!==arguments[3]&&arguments[3];if(Array.isArray(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i in n)if(n.hasOwnProperty(i)&&-1===t.indexOf(i))if(n[i]&&n[i].constructor===Object)void 0===e[i]&&(e[i]={}),e[i].constructor===Object?u.deepExtend(e[i],n[i]):a(e,n,i,r);else if(Array.isArray(n[i])){e[i]=[];for(var s=0;s<n[i].length;s++)e[i].push(n[i][s])}else a(e,n,i,r);return e},u.deepExtend=function(t,e){var n=2<arguments.length&&void 0!==arguments[2]&&arguments[2],r=3<arguments.length&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(e.hasOwnProperty(i)||!0===n)if(e[i]&&e[i].constructor===Object)void 0===t[i]&&(t[i]={}),t[i].constructor===Object?u.deepExtend(t[i],e[i],n):a(t,e,i,r);else if(Array.isArray(e[i])){t[i]=[];for(var s=0;s<e[i].length;s++)t[i].push(e[i][s])}else a(t,e,i,r);return t},u.equalArray=function(t,e){if(t.length!=e.length)return!1;for(var n=0,r=t.length;n<r;n++)if(t[n]!=e[n])return!1;return!0},u.convert=function(t,e){var n;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return u.isString(t)&&!isNaN(Date.parse(t))?i(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(u.isNumber(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(i.isMoment(t))return new Date(t.valueOf());if(u.isString(t))return(n=r.exec(t))?new Date(Number(n[1])):i(new Date(t)).toDate();throw new Error("Cannot convert object of type "+u.getType(t)+" to type Date");case"Moment":if(u.isNumber(t))return i(t);if(t instanceof Date)return i(t.valueOf());if(i.isMoment(t))return i(t);if(u.isString(t))return n=r.exec(t),i(n?Number(n[1]):t);throw new Error("Cannot convert object of type "+u.getType(t)+" to type Date");case"ISODate":if(u.isNumber(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(i.isMoment(t))return t.toDate().toISOString();if(u.isString(t))return(n=r.exec(t))?new Date(Number(n[1])).toISOString():i(t).format();throw new Error("Cannot convert object of type "+u.getType(t)+" to type ISODate");case"ASPDate":if(u.isNumber(t))return"/Date("+t+")/";if(t instanceof Date)return"/Date("+t.valueOf()+")/";if(u.isString(t))return"/Date("+((n=r.exec(t))?new Date(Number(n[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+u.getType(t)+" to type ASPDate");default:throw new Error('Unknown type "'+e+'"')}}};var r=/^\/?Date\((\-?\d+)/i;u.getType=function(t){var e=h(t);return"object"==e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Array.isArray(t)?"Array":t instanceof Date?"Date":"Object":"number"==e?"Number":"boolean"==e?"Boolean":"string"==e?"String":void 0===e?"undefined":e},u.copyAndExtendArray=function(t,e){for(var n=[],r=0;r<t.length;r++)n.push(t[r]);return n.push(e),n},u.copyArray=function(t){for(var e=[],n=0;n<t.length;n++)e.push(t[n]);return e},u.getAbsoluteLeft=function(t){return t.getBoundingClientRect().left},u.getAbsoluteRight=function(t){return t.getBoundingClientRect().right},u.getAbsoluteTop=function(t){return t.getBoundingClientRect().top},u.addClassName=function(t,e){var n=t.className.split(" "),r=e.split(" ");n=n.concat(r.filter(function(t){return n.indexOf(t)<0})),t.className=n.join(" ")},u.removeClassName=function(t,e){var n=t.className.split(" "),r=e.split(" ");n=n.filter(function(t){return r.indexOf(t)<0}),t.className=n.join(" ")},u.forEach=function(t,e){var n,r;if(Array.isArray(t))for(n=0,r=t.length;n<r;n++)e(t[n],n,t);else for(n in t)t.hasOwnProperty(n)&&e(t[n],n,t)},u.toArray=function(t){var e=[];for(var n in t)t.hasOwnProperty(n)&&e.push(t[n]);return e},u.updateProperty=function(t,e,n){return t[e]!==n&&(t[e]=n,!0)},u.throttle=function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame(function(){e=!1,t()}))}},u.addEventListener=function(t,e,n,r){t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&0<=navigator.userAgent.indexOf("Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,n,r)):t.attachEvent("on"+e,n)},u.removeEventListener=function(t,e,n,r){t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&0<=navigator.userAgent.indexOf("Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,n,r)):t.detachEvent("on"+e,n)},u.preventDefault=function(t){(t=t||window.event).preventDefault?t.preventDefault():t.returnValue=!1},u.getTarget=function(t){var e;return(t=t||window.event).target?e=t.target:t.srcElement&&(e=t.srcElement),null!=e.nodeType&&3==e.nodeType&&(e=e.parentNode),e},u.hasParent=function(t,e){for(var n=t;n;){if(n===e)return!0;n=n.parentNode}return!1},u.option={},u.option.asBoolean=function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},u.option.asNumber=function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},u.option.asString=function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},u.option.asSize=function(t,e){return"function"==typeof t&&(t=t()),u.isString(t)?t:u.isNumber(t)?t+"px":e||null},u.option.asElement=function(t,e){return"function"==typeof t&&(t=t()),t||e||null},u.hexToRGB=function(t){t=t.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,function(t,e,n,r){return e+e+n+n+r+r});var e=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(t);return e?{r:parseInt(e[1],16),g:parseInt(e[2],16),b:parseInt(e[3],16)}:null},u.overrideOpacity=function(t,e){var n;return-1!=t.indexOf("rgba")?t:-1!=t.indexOf("rgb")?"rgba("+(n=t.substr(t.indexOf("(")+1).replace(")","").split(","))[0]+","+n[1]+","+n[2]+","+e+")":null==(n=u.hexToRGB(t))?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},u.RGBToHex=function(t,e,n){return"#"+((1<<24)+(t<<16)+(e<<8)+n).toString(16).slice(1)},u.parseColor=function(t){var e;if(!0===u.isString(t)){if(!0===u.isValidRGB(t)){var n=t.substr(4).substr(0,t.length-5).split(",").map(function(t){return parseInt(t)});t=u.RGBToHex(n[0],n[1],n[2])}if(!0===u.isValidHex(t)){var r=u.hexToHSV(t),i={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},s={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},a=u.HSVToHex(s.h,s.s,s.v),o=u.HSVToHex(i.h,i.s,i.v);e={background:t,border:a,highlight:{background:o,border:a},hover:{background:o,border:a}}}else e={background:t,border:t,highlight:{background:t,border:t},hover:{background:t,border:t}}}else(e={}).background=t.background||void 0,e.border=t.border||void 0,u.isString(t.highlight)?e.highlight={border:t.highlight,background:t.highlight}:(e.highlight={},e.highlight.background=t.highlight&&t.highlight.background||void 0,e.highlight.border=t.highlight&&t.highlight.border||void 0),u.isString(t.hover)?e.hover={border:t.hover,background:t.hover}:(e.hover={},e.hover.background=t.hover&&t.hover.background||void 0,e.hover.border=t.hover&&t.hover.border||void 0);return e},u.RGBToHSV=function(t,e,n){t/=255,e/=255,n/=255;var r=Math.min(t,Math.min(e,n)),i=Math.max(t,Math.max(e,n));return r==i?{h:0,s:0,v:r}:{h:60*((t==r?3:n==r?1:5)-(t==r?e-n:n==r?t-e:n-t)/(i-r))/360,s:(i-r)/i,v:i}};var s=function(t){var i={};return t.split(";").forEach(function(t){if(""!=t.trim()){var e=t.split(":"),n=e[0].trim(),r=e[1].trim();i[n]=r}}),i},o=function(e){return Object.keys(e).map(function(t){return t+": "+e[t]}).join("; ")};u.addCssText=function(t,e){var n=s(t.style.cssText),r=s(e),i=u.extend(n,r);t.style.cssText=o(i)},u.removeCssText=function(t,e){var n=s(t.style.cssText),r=s(e);for(var i in r)r.hasOwnProperty(i)&&delete n[i];t.style.cssText=o(n)},u.HSVToRGB=function(t,e,n){var r,i,s,a=Math.floor(6*t),o=6*t-a,u=n*(1-e),l=n*(1-o*e),h=n*(1-(1-o)*e);switch(a%6){case 0:r=n,i=h,s=u;break;case 1:r=l,i=n,s=u;break;case 2:r=u,i=n,s=h;break;case 3:r=u,i=l,s=n;break;case 4:r=h,i=u,s=n;break;case 5:r=n,i=u,s=l}return{r:Math.floor(255*r),g:Math.floor(255*i),b:Math.floor(255*s)}},u.HSVToHex=function(t,e,n){var r=u.HSVToRGB(t,e,n);return u.RGBToHex(r.r,r.g,r.b)},u.hexToHSV=function(t){var e=u.hexToRGB(t);return u.RGBToHSV(e.r,e.g,e.b)},u.isValidHex=function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)},u.isValidRGB=function(t){return t=t.replace(" ",""),/rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/i.test(t)},u.isValidRGBA=function(t){return t=t.replace(" ",""),/rgba\((\d{1,3}),(\d{1,3}),(\d{1,3}),(.{1,3})\)/i.test(t)},u.selectiveBridgeObject=function(t,e){if(null===e||"object"!==h(e))return null;for(var n=Object.create(e),r=0;r<t.length;r++)e.hasOwnProperty(t[r])&&"object"==h(e[t[r]])&&(n[t[r]]=u.bridgeObject(e[t[r]]));return n},u.bridgeObject=function(t){if(null===t||"object"!==h(t))return null;var e=Object.create(t);if(t instanceof Element)e=t;else for(var n in e=Object.create(t),t)t.hasOwnProperty(n)&&"object"==h(t[n])&&(e[n]=u.bridgeObject(t[n]));return e},u.insertSort=function(t,e){for(var n=0;n<t.length;n++){for(var r=t[n],i=n;0<i&&e(r,t[i-1])<0;i--)t[i]=t[i-1];t[i]=r}return t},u.mergeOptions=function(t,e,n){function r(t){return null!=t}function a(t){return null!==t&&"object"===h(t)}var i=3<arguments.length&&void 0!==arguments[3]?arguments[3]:{};if(!a(t))throw new Error("Parameter mergeTarget must be an object");if(!a(e))throw new Error("Parameter options must be an object");if(!r(n))throw new Error("Parameter option must have a value");if(!a(i))throw new Error("Parameter globalOptions must be an object");var s=e[n],o=a(i)&&!function(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}(i)?i[n]:void 0,u=o?o.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return a(t[n])||(t[n]={}),void(t[n].enabled=s);if(null===s&&!a(t[n])){if(!r(o))return;t[n]=Object.create(o)}if(a(s)){var l=!0;void 0!==s.enabled?l=s.enabled:void 0!==u&&(l=o.enabled),function(t,e,n){a(t[n])||(t[n]={});var r=e[n],i=t[n];for(var s in r)r.hasOwnProperty(s)&&(i[s]=r[s])}(t,e,n),t[n].enabled=l}}},u.binarySearchCustom=function(t,e,n,r){for(var i=0,s=0,a=t.length-1;s<=a&&i<1e4;){var o=Math.floor((s+a)/2),u=t[o],l=e(void 0===r?u[n]:u[n][r]);if(0==l)return o;-1==l?s=o+1:a=o-1,i++}return-1},u.binarySearchValue=function(t,e,n,r,i){var s,a,o,u,l=0,h=0,d=t.length-1;for(i=null!=i?i:function(t,e){return t==e?0:t<e?-1:1};h<=d&&l<1e4;){if(u=Math.floor(.5*(d+h)),s=t[Math.max(0,u-1)][n],a=t[u][n],o=t[Math.min(t.length-1,u+1)][n],0==i(a,e))return u;if(i(s,e)<0&&0<i(a,e))return"before"==r?Math.max(0,u-1):u;if(i(a,e)<0&&0<i(o,e))return"before"==r?u:Math.min(t.length-1,u+1);i(a,e)<0?h=u+1:d=u-1,l++}return-1},u.easingFunctions={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},u.getScrollBarWidth=function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var n=t.offsetWidth;e.style.overflow="scroll";var r=t.offsetWidth;return n==r&&(r=e.clientWidth),document.body.removeChild(e),n-r},u.topMost=function(t,e){var n;Array.isArray(e)||(e=[e]);var r=!0,i=!1,s=void 0;try{for(var a,o=t[Symbol.iterator]();!(r=(a=o.next()).done);r=!0){var u=a.value;if(u){n=u[e[0]];for(var l=1;l<e.length;l++)n=n&&n[e[l]];if(void 0!==n)break}}}catch(t){i=!0,s=t}finally{try{r||null==o.return||o.return()}finally{if(i)throw s}}return n}});g.isNumber,g.recursiveDOMDelete,g.isString,g.isDate,g.randomUUID,g.fillIfDefined,g.extend,g.selectiveExtend,g.selectiveDeepExtend,g.selectiveNotDeepExtend,g.deepExtend,g.equalArray,g.convert,g.getType,g.copyAndExtendArray,g.copyArray,g.getAbsoluteLeft,g.getAbsoluteRight,g.getAbsoluteTop,g.addClassName,g.removeClassName,g.forEach,g.toArray,g.updateProperty,g.throttle,g.addEventListener,g.removeEventListener,g.preventDefault,g.getTarget,g.hasParent,g.option,g.hexToRGB,g.overrideOpacity,g.RGBToHex,g.parseColor,g.RGBToHSV,g.addCssText,g.removeCssText,g.HSVToRGB,g.HSVToHex,g.hexToHSV,g.isValidHex,g.isValidRGB,g.isValidRGBA,g.selectiveBridgeObject,g.bridgeObject,g.insertSort,g.mergeOptions,g.binarySearchCustom,g.binarySearchValue,g.easingFunctions,g.getScrollBarWidth,g.topMost;function v(t){this.delay=null,this.max=1/0,this._queue=[],this._timeout=null,this._extended=null,this.setOptions(t)}v.prototype.setOptions=function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()},v.extend=function(t,e){var n=new v(e);if(void 0!==t.flush)throw new Error("Target object already has a property flush");t.flush=function(){n.flush()};var r=[{name:"flush",original:void 0}];if(e&&e.replace)for(var i=0;i<e.replace.length;i++){var s=e.replace[i];r.push({name:s,original:t[s]}),n.replace(t,s)}return n._extended={object:t,methods:r},n},v.prototype.destroy=function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,n=0;n<e.length;n++){var r=e[n];r.original?t[r.name]=r.original:delete t[r.name]}this._extended=null}},v.prototype.replace=function(t,e){var n=this,r=t[e];if(!r)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];n.queue({args:t,fn:r,context:this})}},v.prototype.queue=function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()},v.prototype._flushIfNeeded=function(){if(this._queue.length>this.max&&this.flush(),clearTimeout(this._timeout),0<this.queue.length&&"number"==typeof this.delay){var t=this;this._timeout=setTimeout(function(){t.flush()},this.delay)}},v.prototype.flush=function(){for(;0<this._queue.length;){var t=this._queue.shift();t.fn.apply(t.context||t.fn,t.args||[])}};var w=v;function b(t,e){if(t&&!Array.isArray(t)&&(e=t,t=null),this._options=e||{},this._data={},this.length=0,this._fieldId=this._options.fieldId||"id",this._type={},this._options.type)for(var n=Object.keys(this._options.type),r=0,i=n.length;r<i;r++){var s=n[r],a=this._options.type[s];this._type[s]="Date"==a||"ISODate"==a||"ASPDate"==a?"Date":a}this._subscribers={},t&&this.add(t),this.setOptions(e)}b.prototype.setOptions=function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=w.extend(this,{replace:["add","update","remove"]})),"object"===f(t.queue)&&this._queue.setOptions(t.queue)))},b.prototype.on=function(t,e){var n=this._subscribers[t];n||(n=[],this._subscribers[t]=n),n.push({callback:e})},b.prototype.off=function(t,e){var n=this._subscribers[t];n&&(this._subscribers[t]=n.filter(function(t){return t.callback!=e}))},b.prototype._trigger=function(t,e,n){if("*"==t)throw new Error("Cannot trigger event *");var r=[];t in this._subscribers&&(r=r.concat(this._subscribers[t])),"*"in this._subscribers&&(r=r.concat(this._subscribers["*"]));for(var i=0,s=r.length;i<s;i++){var a=r[i];a.callback&&a.callback(t,e,n||null)}},b.prototype.add=function(t,e){var n,r=[];if(Array.isArray(t))for(var i=0,s=t.length;i<s;i++)n=this._addItem(t[i]),r.push(n);else{if(!t||"object"!==f(t))throw new Error("Unknown dataType");n=this._addItem(t),r.push(n)}return r.length&&this._trigger("add",{items:r},e),r},b.prototype.update=function(t,e){function n(t){var e=t[u];if(o._data[e]){var n=g.extend({},o._data[e]);e=o._updateItem(t),i.push(e),a.push(t),s.push(n)}else e=o._addItem(t),r.push(e)}var r=[],i=[],s=[],a=[],o=this,u=o._fieldId;if(Array.isArray(t))for(var l=0,h=t.length;l<h;l++)t[l]&&"object"===f(t[l])?n(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==f(t))throw new Error("Unknown dataType");n(t)}if(r.length&&this._trigger("add",{items:r},e),i.length){var d={items:i,oldData:s,data:a};this._trigger("update",d,e)}return r.concat(i)},b.prototype.get=function(t){var e,n,r,i,s=g.getType(t);if((r="String"==s||"Number"==s?(e=t,arguments[1]):"Array"==s?(n=t,arguments[1]):t)&&r.returnType){i=-1==["Array","Object"].indexOf(r.returnType)?"Array":r.returnType}else i="Array";var a,o,u,l,h,d=r&&r.type||this._options.type,f=r&&r.filter,c=[];if(null!=e)(a=this._getItem(e,d))&&f&&!f(a)&&(a=null);else if(null!=n)for(l=0,h=n.length;l<h;l++)a=this._getItem(n[l],d),f&&!f(a)||c.push(a);else for(l=0,h=(o=Object.keys(this._data)).length;l<h;l++)u=o[l],a=this._getItem(u,d),f&&!f(a)||c.push(a);if(r&&r.order&&null==e&&this._sort(c,r.order),r&&r.fields){var m=r.fields;if(null!=e)a=this._filterFields(a,m);else for(l=0,h=c.length;l<h;l++)c[l]=this._filterFields(c[l],m)}if("Object"!=i)return null!=e?a:c;var _,p={};for(l=0,h=c.length;l<h;l++)p[(_=c[l]).id]=_;return p},b.prototype.getIds=function(t){var e,n,r,i,s,a=this._data,o=t&&t.filter,u=t&&t.order,l=t&&t.type||this._options.type,h=Object.keys(a),d=[];if(o)if(u){for(s=[],e=0,n=h.length;e<n;e++)r=h[e],o(i=this._getItem(r,l))&&s.push(i);for(this._sort(s,u),e=0,n=s.length;e<n;e++)d.push(s[e][this._fieldId])}else for(e=0,n=h.length;e<n;e++)r=h[e],o(i=this._getItem(r,l))&&d.push(i[this._fieldId]);else if(u){for(s=[],e=0,n=h.length;e<n;e++)r=h[e],s.push(a[r]);for(this._sort(s,u),e=0,n=s.length;e<n;e++)d.push(s[e][this._fieldId])}else for(e=0,n=h.length;e<n;e++)i=a[r=h[e]],d.push(i[this._fieldId]);return d},b.prototype.getDataSet=function(){return this},b.prototype.forEach=function(t,e){var n,r,i,s,a=e&&e.filter,o=e&&e.type||this._options.type,u=this._data,l=Object.keys(u);if(e&&e.order){var h=this.get(e);for(n=0,r=h.length;n<r;n++)t(i=h[n],s=i[this._fieldId])}else for(n=0,r=l.length;n<r;n++)s=l[n],i=this._getItem(s,o),a&&!a(i)||t(i,s)},b.prototype.map=function(t,e){var n,r,i,s,a=e&&e.filter,o=e&&e.type||this._options.type,u=[],l=this._data,h=Object.keys(l);for(n=0,r=h.length;n<r;n++)i=h[n],s=this._getItem(i,o),a&&!a(s)||u.push(t(s,i));return e&&e.order&&this._sort(u,e.order),u},b.prototype._filterFields=function(t,e){if(!t)return t;var n,r,i={},s=Object.keys(t),a=s.length;if(Array.isArray(e))for(n=0;n<a;n++)r=s[n],-1!=e.indexOf(r)&&(i[r]=t[r]);else for(n=0;n<a;n++)r=s[n],e.hasOwnProperty(r)&&(i[e[r]]=t[r]);return i},b.prototype._sort=function(t,e){if(g.isString(e)){var i=e;t.sort(function(t,e){var n=t[i],r=e[i];return r<n?1:n<r?-1:0})}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");t.sort(e)}},b.prototype.remove=function(t,e){var n,r,i,s,a,o=[],u=[];for(r=0,i=(n=Array.isArray(t)?t:[t]).length;r<i;r++)(a=this._remove(n[r]))&&null!=(s=a[this._fieldId])&&(o.push(s),u.push(a));return o.length&&this._trigger("remove",{items:o,oldData:u},e),o},b.prototype._remove=function(t){var e,n;return g.isNumber(t)||g.isString(t)?n=t:t&&"object"===f(t)&&(n=t[this._fieldId]),void 0!==n&&this._data[n]?(e=this._data[n],delete this._data[n],this.length--,e):null},b.prototype.clear=function(t){var e,n,r=Object.keys(this._data),i=[];for(e=0,n=r.length;e<n;e++)i.push(this._data[r[e]]);return this._data={},this.length=0,this._trigger("remove",{items:r,oldData:i},t),r},b.prototype.max=function(t){var e,n,r=this._data,i=Object.keys(r),s=null,a=null;for(e=0,n=i.length;e<n;e++){var o=r[i[e]],u=o[t];null!=u&&(!s||a<u)&&(s=o,a=u)}return s},b.prototype.min=function(t){var e,n,r=this._data,i=Object.keys(r),s=null,a=null;for(e=0,n=i.length;e<n;e++){var o=r[i[e]],u=o[t];null!=u&&(!s||u<a)&&(s=o,a=u)}return s},b.prototype.distinct=function(t){var e,n,r,i=this._data,s=Object.keys(i),a=[],o=this._options.type&&this._options.type[t]||null,u=0;for(e=0,r=s.length;e<r;e++){var l=i[s[e]][t],h=!1;for(n=0;n<u;n++)if(a[n]==l){h=!0;break}h||void 0===l||(a[u]=l,u++)}if(o)for(e=0,r=a.length;e<r;e++)a[e]=g.convert(a[e],o);return a},b.prototype._addItem=function(t){var e=t[this._fieldId];if(null!=e){if(this._data[e])throw new Error("Cannot add item: item with id "+e+" already exists")}else e=g.randomUUID(),t[this._fieldId]=e;var n,r,i={},s=Object.keys(t);for(n=0,r=s.length;n<r;n++){var a=s[n],o=this._type[a];i[a]=g.convert(t[a],o)}return this._data[e]=i,this.length++,e},b.prototype._getItem=function(t,e){var n,r,i,s,a=this._data[t];if(!a)return null;var o={},u=Object.keys(a);if(e)for(i=0,s=u.length;i<s;i++)r=a[n=u[i]],o[n]=g.convert(r,e[n]);else for(i=0,s=u.length;i<s;i++)r=a[n=u[i]],o[n]=r;return o[this._fieldId]||(o[this._fieldId]=a.id),o},b.prototype._updateItem=function(t){var e=t[this._fieldId];if(null==e)throw new Error("Cannot update item: item has no id (item: "+JSON.stringify(t)+")");var n=this._data[e];if(!n)throw new Error("Cannot update item: no item with id "+e+" found");for(var r=Object.keys(t),i=0,s=r.length;i<s;i++){var a=r[i],o=this._type[a];n[a]=g.convert(t[a],o)}return e};var S=b;function D(t,e){this._data=null,this._ids={},this.length=0,this._options=e||{},this._fieldId="id",this._subscribers={};var n=this;this.listener=function(){n._onEvent.apply(n,arguments)},this.setData(t)}D.prototype.setData=function(t){var e,n,r,i,s;if(this._data){for(this._data.off&&this._data.off("*",this.listener),s=[],r=0,i=(e=this._data.getIds({filter:this._options&&this._options.filter})).length;r<i;r++)s.push(this._data._data[e[r]]);this._ids={},this.length=0,this._trigger("remove",{items:e,oldData:s})}if(this._data=t,this._data){for(this._fieldId=this._options.fieldId||this._data&&this._data.options&&this._data.options.fieldId||"id",r=0,i=(e=this._data.getIds({filter:this._options&&this._options.filter})).length;r<i;r++)n=e[r],this._ids[n]=!0;this.length=e.length,this._trigger("add",{items:e}),this._data.on&&this._data.on("*",this.listener)}},D.prototype.refresh=function(){var t,e,n,r=this._data.getIds({filter:this._options&&this._options.filter}),i=Object.keys(this._ids),s={},a=[],o=[],u=[];for(e=0,n=r.length;e<n;e++)s[t=r[e]]=!0,this._ids[t]||(a.push(t),this._ids[t]=!0);for(e=0,n=i.length;e<n;e++)s[t=i[e]]||(o.push(t),u.push(this._data._data[t]),delete this._ids[t]);this.length+=a.length-o.length,a.length&&this._trigger("add",{items:a}),o.length&&this._trigger("remove",{items:o,oldData:u})},D.prototype.get=function(t){var e,n,r,i=this,s=g.getType(t);r="String"==s||"Number"==s||"Array"==s?(e=t,n=arguments[1],arguments[2]):(n=t,arguments[1]);var a=g.extend({},this._options,n);this._options.filter&&n&&n.filter&&(a.filter=function(t){return i._options.filter(t)&&n.filter(t)});var o=[];return null!=e&&o.push(e),o.push(a),o.push(r),this._data&&this._data.get.apply(this._data,o)},D.prototype.getIds=function(e){var t;if(this._data){var n,r=this._options.filter;n=e&&e.filter?r?function(t){return r(t)&&e.filter(t)}:e.filter:r,t=this._data.getIds({filter:n,order:e&&e.order})}else t=[];return t},D.prototype.forEach=function(t,e){if(this._data){var n,r=this._options.filter;n=e&&e.filter?r?function(t){return r(t)&&e.filter(t)}:e.filter:r,this._data.forEach(t,{filter:n,order:e&&e.order})}},D.prototype.map=function(t,e){var n=[];if(this._data){var r,i=this._options.filter;r=e&&e.filter?i?function(t){return i(t)&&e.filter(t)}:e.filter:i,n=this._data.map(t,{filter:r,order:e&&e.order})}else n=[];return n},D.prototype.getDataSet=function(){for(var t=this;t instanceof D;)t=t._data;return t||null},D.prototype._onEvent=function(t,e,n){var r,i,s,a=e&&e.items,o=[],u=[],l=[],h=[],d=[],f=[];if(a&&this._data){switch(t){case"add":for(r=0,i=a.length;r<i;r++)s=a[r],this.get(s)&&(this._ids[s]=!0,o.push(s));break;case"update":for(r=0,i=a.length;r<i;r++)s=a[r],this.get(s)?this._ids[s]?(u.push(s),d.push(e.data[r]),h.push(e.oldData[r])):(this._ids[s]=!0,o.push(s)):this._ids[s]&&(delete this._ids[s],l.push(s),f.push(e.oldData[r]));break;case"remove":for(r=0,i=a.length;r<i;r++)s=a[r],this._ids[s]&&(delete this._ids[s],l.push(s),f.push(e.oldData[r]))}this.length+=o.length-l.length,o.length&&this._trigger("add",{items:o},n),u.length&&this._trigger("update",{items:u,oldData:h,data:d},n),l.length&&this._trigger("remove",{items:l,oldData:f},n)}},D.prototype.on=S.prototype.on,D.prototype.off=S.prototype.off,D.prototype._trigger=S.prototype._trigger,D.prototype.subscribe=D.prototype.on,D.prototype.unsubscribe=D.prototype.off;var k=S,M=D,O=w,x={DataSet:k,DataView:M,Queue:O};t.DataSet=k,t.DataView=M,t.Queue=O,t.default=x,Object.defineProperty(t,"__esModule",{value:!0})});
